package com.eneraptor.hci

import groovy.sql.*
import java.sql.*

class ConfigController {
	
	def dataSource

    def main = { }
	
	def hci = {
		
		/*
		 * DISK USAGE - ONLY IF ENERAPTOR HCI IS SUPERUSER
		 */ 
		def totalSpace = 0
		def freeSpace = 0
		def percent = 0
		/*
		def db_sql = new Sql(dataSource)
		
		def single = db_sql.firstRow("show data_directory")
		def loca = single.data_directory
		def partition = new File(loca)
		totalSpace = partition.getTotalSpace()
		freeSpace  = partition.getFreeSpace()
		
		totalSpace = (int)((totalSpace/1024)/1024)
		freeSpace = (int)((freeSpace/1024)/1024)
		
		percent = 100 - ((int) ((freeSpace/totalSpace)*100))
		
		*/
		
		def allDevices = DeviceInfo.list()
		[conf: InternalConfig, devices: allDevices, totalSpace: totalSpace, freeSpace: freeSpace, percent: percent]		
	}
	
	def addDevice = {
	}
	
	def addDeviceSave = {
		def newDevice = new DeviceInfo(params)
		if(newDevice.validate() && (params.inputDevice || params.outputDevice)) {
			newDevice.save()
			flash['confirms'] = "<p>New device added successfully.</p>"
			redirect(action:'hci')
		} else {
			flash['errors'] = "<p>New device was not saved. Check input data.</p>"
			if(!params.inputDevice && !params.outputDevice)
				flash['errors'] += "<p>Device must be capable of making masurements, actions or both. You have selected none.</p>"
			redirect(action:'addDevice', params: params)
		}
	}
	
	def deleteHciEntry = {
		
		def deviceToBeDeleted = DeviceInfo.findById(params.id)
		
		if(deviceToBeDeleted) {
			deviceToBeDeleted.delete()
			flash['confirms'] = "<p>Device deleted succesfully.</p>"
		} else {
			flash['errors'] = "<p>There was no device deleted.</p><p>There was no device with id ${params.id}.</p>"
		}
		redirect(action: 'hci')
		
	}
	
	def changeHciEntry = {
		
		def deviceToBeChanged = DeviceInfo.findById(params.id)
		if(!deviceToBeChanged) {
			flash['errors'] = "<p>There is no device with id ${params.id}.</p>"
			redirect(action: 'hci')
			return false
		}
		deviceToBeChanged.getProperties()
    }
	
	def changeHciEntrySave = {
		
		def deviceToBeUpdated = DeviceInfo.findById(params.id)
		deviceToBeUpdated.properties = params
		if(deviceToBeUpdated.save()) {
			flash['confirms'] = "<p>Device updated succesfully.</p>"
			redirect(action: 'hci')
		} else {
			flash['errors'] = "<p>Device was not changed.</p>"
			redirect(action:'changeHciEntry', params: params)
		}
		
	}
	
	def dbInfo = {
		
		List databaseInfo = new ArrayList()
		def db_sql = new Sql(dataSource)
		db_sql.eachRow "SHOW ALL", {
			databaseInfo << it.toRowResult()
		}
		
		[databaseInfo: databaseInfo]
		
	}
	
	def logic = {
		
		[conf: InternalConfig]
		
	}
	
	def connection = {
		
		[conf: InternalConfig]
		
	}
	
	def saveConnection = {
		
		if(params['logic-ip'] == 'localhost') params['logic-ip'] = '127.0.0.1'
		
		if(params['logic-ip'] && params['logic-port']) {
			InternalConfig.findByConfigId('logic-ip').configVal = params['logic-ip']
			InternalConfig.findByConfigId('logic-port').configVal = params['logic-port']
			flash['confirms'] = "<p>Changes saved.</p>"
			redirect(action: 'connection')
		} else {
			flash['errors'] = "<p>Logic IP address and port fields cannot be blank.</p>"
			redirect(action: 'connection')
		}
		
	}
	
	def dbExec = {
		
		if(params['sqlQuery']) {
			
			flash['confirms'] = null
			flash['errors'] = null
			
			def db_sql = new Sql(dataSource)
			List rows
			List keys = new ArrayList()
			boolean wasError = false
			try {
				rows = db_sql.rows(params['sqlQuery'])
				rows[0].each {
					keys << it.key
				}
				flash['confirms'] = "<p>SQL query executed succesfully. Chrck returned rows below.</p>"
			} catch (SQLException e) {
				rows = new ArrayList()
				if(e.getSQLState().equals("02000")) {
					keys << 'SQL query result'
					rows << ['SQL query result' : 'No rows were returned.']
					flash['confirms'] = "<p>SQL query executed succesfully.</p>"
				} else {
					rows << e
					rows << e.getSQLState()
					wasError = true
					flash['errors'] = "<p>There was an error while executing the SQL query. Check the report below.</p><p>The query was not executed</p>"
				}
			}
			return [sqlResult: rows, keys: keys, wasError: wasError]
		}
		
	}
	
	def getHelp = {
		[what : params.what]
	}
	
}
